"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCStarMessagePredicateNode subclass:#PPCTokenStarMessagePredicateNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCTokenStarMessagePredicateNode methodsFor:'as yet unclassified'!

asFast
	^ self
!

asInlined
	^ PPCInlineTokenStarMessagePredicateNode new
		name: name;
		message: message;
		child: child;
		yourself
!

compileWith: compiler effect: effect id: id
	compiler startMethod: id.
	compiler add: '[ context peek ', message,' ] whileTrue: ['.
	compiler indent.
	compiler add: 'context next'.
	compiler indent.
	compiler dedent.
	compiler add: '].'.
 ^ compiler stopMethod.
!

rewrite: changeStatus

	(message = #isSeparator) ifTrue: [ 
		changeStatus change.
		^ PPCTokenStarSeparatorNode new
			name: name;
			child: child;
			message: message;
			yourself.
	]
! !

